PRO drz_healp_coo2phi_theta,c1,c2,phi,theta,healp_header,fits_header

;transforms coordinates c1,c2 (of the kind given infits_header)
;into phi,theta (of the kind described in healp_header)
;phi theta in degrees
;c1,c2 in degrees
;Caution: Equinox not taken into account for ecliptic coordinates
;Caution: Code not fully tested.
 
Nside=sxpar(healp_header,'NSIDE')
ordering=strtrim(sxpar(healp_header,'ORDERING'),2)
coordsys=strtrim(sxpar(healp_header,'COORDSYS'),2)

ctype1=sxpar(fits_header,'CTYPE1')
ctype2=sxpar(fits_header,'CTYPE2')

eq_healp=2000.    ;healpix assumes J2000

csys=coordsys
CASE coordsys OF
  'EQU':csys='Q'
  'ECL':csys='E'
  'GAL':csys='G'
  ELSE:goto,suite
ENDCASE
suite:

ct1=strmid(ctype1,0,4)

;This is to avoid changing c1,c2 on output
cc1=c1
cc2=c2

CASE ct1 OF  ;case on fits proj type
  'RA--':BEGIN
    eq_fits=sxpar(fits_header,'EQUINOX',count=cc)
    IF cc EQ 0 THEN BEGIN
      eq_fits=sxpar(fits_header,'EPOCH',count=cc)
      IF cc EQ 0 THEN BEGIN
        message,'FITS EQUINOX assumed to be 1950',/info
        eq_fits=1950.
      ENDIF
    ENDIF
;    stop
    CASE csys OF
      'G':BEGIN
        IF drz_astron_default_equinox() NE eq_fits THEN BEGIN
          precess_array,cc1,cc2,eq_fits,drz_astron_default_equinox()
        ENDIF        
        euler,cc1,cc2,phi,theta,1  ;Radec to Galactic
        theta=90.-theta
;        print,'toto'
      END
      'Q':BEGIN
        IF drz_astron_default_equinox() NE eq_fits THEN BEGIN
          precess_array,cc1,cc2,eq_fits,eq_healp
        ENDIF
        phi=cc1 & theta=90.-cc2
      END
      'E':BEGIN
        IF drz_astron_default_equinox() NE eq_fits THEN BEGIN
          precess_array,cc1,cc2,eq_fits,drz_astron_default_equinox()
        ENDIF
        euler,cc1,cc2,phi,theta,3         ;ra,dec to Ecliptic
        theta=90.-theta
      END
    ENDCASE
  END
  'ELON':BEGIN
    CASE csys OF
      'G':BEGIN
        euler,cc1,cc2,phi,theta,5        ;ecliptic to galactic
        theta=90.-theta
      END
      'Q':BEGIN
         euler,cc1,cc2,phi,theta,4         ;Ecliptic to equatorial
         IF drz_astron_default_equinox() NE eq_healp THEN BEGIN
           precess_array,phi,theta,drz_astron_default_equinox(),eq_healp
         ENDIF
         theta=90.-theta
      END
      'E':BEGIN
        phi=cc1 & theta=90.-cc2
      END
    ENDCASE
  END
  'GLON':BEGIN
    CASE csys OF
      'G':BEGIN
        phi=cc1 & theta=90.-cc2
      END
      'Q':BEGIN
         euler,cc1,cc2,phi,theta,2    ;Galactic to Equatorial
         IF drz_astron_default_equinox() NE eq_healp THEN BEGIN
           precess_array,phi,theta,drz_astron_default_equinox(),eq_healp
         ENDIF
         theta=90.-theta
      END
      'E':BEGIN
         euler,cc1,cc2,phi,theta,6       ;Galactic to ecliptic
         theta=90.-theta
      END
    ENDCASE
  END
ENDCASE

;To force the angles
p = where((theta gt 180.) or (theta lt 0.), ct)
if ct ne 0 then begin
    phi(p) = phi(p) + 180.
    theta(p) = (360. - theta(p)) mod 360.
endif
phi = (phi+360.) mod 360.

END
