PRO drz_healp_phi_theta2coo,phi,theta,c1,c2,healp_header,fits_header

;transforms healpix phi,theta (of the kind described in healp_header) into coordinates of the
;type given in fits_header
;phi theta in degrees
;c1,c2 in degrees

Nside=sxpar(healp_header,'NSIDE')
ordering=strtrim(sxpar(healp_header,'ORDERING'),2)
coordsys=strtrim(sxpar(healp_header,'COORDSYS'),2)

ctype1=sxpar(fits_header,'CTYPE1')
ctype2=sxpar(fits_header,'CTYPE2')

eq_healp=2000.    ;healpix assumes J2000

csys=coordsys
CASE coordsys OF
  'EQU':csys='Q'
  'ECL':csys='E'
  'GAL':csys='G'
  ELSE:goto,suite
ENDCASE
suite:

ct1=strmid(ctype1,0,4)

CASE ct1 OF
  'RA--':BEGIN
    eq_fits=sxpar(fits_header,'EQUINOX',count=cc)
    IF cc EQ 0 THEN BEGIN
      eq_fits=sxpar(fits_header,'EPOCH',count=cc)
      IF cc EQ 0 THEN BEGIN
        message,'FITS EQUINOX assumed to be 1950',/info
        eq_fits=1950.
      ENDIF
    ENDIF
;    stop
    CASE csys OF
      'G':BEGIN
        euler,phi,90.-theta,c1,c2,2    ;Galactic to ra,dec
        IF drz_astron_default_equinox() NE eq_fits THEN BEGIN
          precess_array,c1,c2,drz_astron_default_equinox(),eq_fits
        ENDIF
      END
      'Q':BEGIN
        c1=phi & c2=90.-theta
        IF drz_astron_default_equinox() NE eq_healp THEN BEGIN
          precess_array,c1,c2,eq_healp,eq_fits
        ENDIF
      END
      'E':BEGIN
        euler,phi,90.-theta,c1,c2,4    ;Ecliptic to ra,dec
        IF drz_astron_default_equinox() NE eq_fits THEN BEGIN
          precess_array,c1,c2,drz_astron_default_equinox(),eq_fits
        ENDIF
      END
    ENDCASE
  END
  'ELON':BEGIN
    CASE csys OF
      'G':BEGIN
        euler,phi,90.-theta,c1,c2,6    ;Galactic to ecliptic
      END
      'Q':BEGIN
         pp=phi
         tt=90.-theta
         IF drz_astron_default_equinox() NE eq_healp THEN BEGIN
           precess_array,pp,tt,eq_healp,drz_astron_default_equinox()
         ENDIF
        euler,pp,tt,c1,c2,3    ;Equatorial to ecliptic
      END
      'E':BEGIN
        c1=phi & c2=90.-theta
      END
    ENDCASE
  END
  'GLON':BEGIN
    CASE csys OF
      'G':BEGIN
        c1=phi & c2=90.-theta
      END
      'Q':BEGIN
         pp=phi
         tt=90.-theta
         IF drz_astron_default_equinox() NE eq_healp THEN BEGIN
           precess_array,pp,tt,eq_healp,drz_astron_default_equinox()
         ENDIF
         euler,pp,tt,c1,c2,1    ;Equatorial to galactic
      END
      'E':BEGIN
         euler,phi,90.-theta,c1,c2,5    ;Ecliptic to galactic
      END
    ENDCASE
  END
ENDCASE

END
