FUNCTION drz_mktemp

;+
; NAME:
;    drz_mktemp
; PURPOSE:
;    generate a temporary file name (no file is created) with a suitable
;    parent directory (e.g. /tmp/xxx-yyyy.tmp on unix
; CATEGORY:
;    JPBLib
; CALLING SEQUENCE: 
;       filepath = mktemp()
; INPUTS:
; OPTIONAL INPUT PARAMETERS:
; OUTPUTS:
;    return an absolute file path to a temporary file
; OPTIONAL OUTPUT PARAMETERS:
; ACCEPTED KEY-WORDS:
; COMMON BLOCKS:
; SIDE EFFECTS:
; RESTRICTIONS:
; PROCEDURE:
; MODIFICATION HISTORY:
;       Written Aug 27 2009 - Alexandre SAUVE
;-

; use the special unix device for random number generation (seed persistent across processus)
openr, devrand, '/dev/urandom', /get_lun
rand_value = 0L
readu, devrand, rand_value
free_lun, devrand

name = string(systime(1), abs(rand_value), format='(%"drz-%d-%d.tmp")')

return, filepath(name, /TMP)


END


